Index: /palm/trunk/SOURCE/turbulence_closure_mod.f90
===================================================================
--- /palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 4509)
+++ /palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 4510)
@@ -1,20 +1,20 @@
 !> @file turbulence_closure_mod.f90
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! This file is part of the PALM model system.
 !
-! PALM is free software: you can redistribute it and/or modify it under the
-! terms of the GNU General Public License as published by the Free Software
-! Foundation, either version 3 of the License, or (at your option) any later
-! version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
-! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with
-! PALM. If not, see <http://www.gnu.org/licenses/>.
-!
-! Copyright 2017-2020 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------!
+! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
+! Public License as published by the Free Software Foundation, either version 3 of the License, or
+! (at your option) any later version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+! Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with PALM. If not, see
+! <http://www.gnu.org/licenses/>.
+!
+! Copyright 1997-2020 Leibniz Universitaet Hannover
+!--------------------------------------------------------------------------------------------------!
+!
 !
 ! Current revisions:
@@ -25,17 +25,19 @@
 ! -----------------
 ! $Id$
+! file re-formatted to follow the PALM coding standard
+!
+! 4495 2020-04-13 20:11:20Z raasch
 ! workaround for Intel14 compiler added
-! 
+!
 ! 4486 2020-04-02 20:45:12Z maronga
-! Bugfix: include topography in calculation of distance_to_wall (1.5-order-dai
-! closure)
-! 
+! Bugfix: include topography in calculation of distance_to_wall (1.5-order-dai closure)
+!
 ! 4481 2020-03-31 18:55:54Z maronga
-! - added new LES closure after Dai et al. (2020), which provides much better grid
-!   convergence in stable boundary layer runs. The implementation is experimental
-!   at the moment and should be used with special care. The new SGS closure can be
-!   switched on via turbulence_closure = '1.5-order-dai'
-! - variable ml_wall_adjusted renamed to delta as it represents a grid size and
-!   not a mixing length (see Equations 14 and 18 in Maronga et al. 2015, GMD)
+! - added new LES closure after Dai et al. (2020), which provides much better grid convergence in
+!   stable boundary layer runs. The implementation is experimental at the moment and should be used
+!   with special care. The new SGS closure can be switched on via
+!   turbulence_closure = '1.5-order-dai'
+! - variable ml_wall_adjusted renamed to delta as it represents a grid size and not a mixing length
+!   (see Equations 14 and 18 in Maronga et al. 2015, GMD)
 ! - nameing of turbulence closures revised:
 !        'Moeng_Wyngaard' to '1.5-order'
@@ -44,5 +46,5 @@
 ! - LOGICAL steering variable renamed:
 !        les_mw to les_default
-! 
+!
 ! 4473 2020-03-25 21:04:07Z gronemeier
 ! - rename l-grid to gridsize-geometric-mean
@@ -54,6 +56,5 @@
 !          l to ml
 ! - adjust some comments
-! - corrected definition of wall-adjusted mixing length to include
-!   gridsize-geometric-mean
+! - corrected definition of wall-adjusted mixing length to include gridsize-geometric-mean
 ! - moved definition of wall_adjustment_factor to this module
 !
@@ -68,6 +69,6 @@
 !
 ! 4346 2019-12-18 11:55:56Z motisi
-! Introduction of wall_flags_total_0, which currently sets bits based on static
-! topography information used in wall_flags_static_0
+! Introduction of wall_flags_total_0, which currently sets bits based on static topography
+! information used in wall_flags_static_0
 !
 ! 4329 2019-12-10 15:46:36Z motisi
@@ -81,6 +82,6 @@
 !
 ! 4170 2019-08-19 17:12:31Z gronemeier
-! - add performance optimizations according to K. Ketelsen
-!   to diffusion_e and tcm_diffusivities_default
+! - add performance optimizations according to K. Ketelsen to diffusion_e and
+!   tcm_diffusivities_default
 ! - bugfix in calculating l_wall for vertical walls
 ! - bugfix in using l_wall in initialization (consider wall_adjustment_factor)
@@ -91,15 +92,12 @@
 !
 ! 4110 2019-07-22 17:05:21Z suehring
-! pass integer flag array as well as boundary flags to WS scalar advection
-! routine
+! pass integer flag array as well as boundary flags to WS scalar advection routine
 !
 ! 4109 2019-07-22 17:00:34Z suehring
 ! - Modularize setting of boundary conditions for TKE and dissipation
 ! - Neumann boundary condition for TKE at model top is set also in child domain
-! - Revise setting of Neumann boundary conditions at non-cyclic lateral
-!   boundaries
-! - Bugfix, set Neumann boundary condition for TKE at vertical wall instead of
-!   an implicit Dirichlet boundary condition which implied a sink of TKE
-!   at vertical walls
+! - Revise setting of Neumann boundary conditions at non-cyclic lateral boundaries
+! - Bugfix, set Neumann boundary condition for TKE at vertical wall instead of an implicit Dirichlet
+!   boundary condition which implied a sink of TKE at vertical walls
 !
 ! 4048 2019-06-21 21:00:21Z knoop
@@ -113,6 +111,6 @@
 !
 ! 3719 2019-02-06 13:10:18Z kanani
-! Changed log_point to log_point_s, otherwise this overlaps with
-! 'all progn.equations' cpu measurement.
+! Changed log_point to log_point_s, otherwise this overlaps with 'all progn.equations' cpu
+! measurement.
 !
 ! 3684 2019-01-20 20:20:58Z knoop
@@ -136,78 +134,131 @@
 !> @todo Check for random disturbances
 !> @note <Enter notes on the module>
-!-----------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  MODULE turbulence_closure_mod
 
 
-    USE arrays_3d,                                                            &
-        ONLY:  diss, diss_1, diss_2, diss_3, diss_p, dzu, e, e_1, e_2, e_3,   &
-               e_p, kh, km, mean_inflow_profiles, prho, pt, tdiss_m,          &
-               te_m, tend, u, v, vpt, w
-
-    USE basic_constants_and_equations_mod,                                    &
-        ONLY:  g, kappa, lv_d_cp, lv_d_rd, rd_d_rv
-
-    USE control_parameters,                                                   &
-        ONLY:  bc_dirichlet_l,                                                &
-               bc_dirichlet_n,                                                &
-               bc_dirichlet_r,                                                &
-               bc_dirichlet_s,                                                &
-               bc_radiation_l,                                                &
-               bc_radiation_n,                                                &
-               bc_radiation_r,                                                &
-               bc_radiation_s,                                                &
-               child_domain,                                                  &
-               constant_diffusion, dt_3d, e_init, humidity,                   &
-               initializing_actions, intermediate_timestep_count,             &
-               intermediate_timestep_count_max, km_constant,                  &
-               les_dai, les_dynamic, les_default,                             &
-               ocean_mode, plant_canopy, prandtl_number,                      &
-               pt_reference, rans_mode, rans_tke_e, rans_tke_l,               &
-               timestep_scheme, turbulence_closure,                           &
-               turbulent_inflow, use_upstream_for_tke, vpt_reference,         &
-               ws_scheme_sca, current_timestep_number
-
-    USE advec_ws,                                                             &
+    USE arrays_3d,                                                                                 &
+        ONLY:  diss,                                                                               &
+               diss_1,                                                                             &
+               diss_2,                                                                             &
+               diss_3,                                                                             &
+               diss_p,                                                                             &
+               dzu,                                                                                &
+               e,                                                                                  &
+               e_1,                                                                                &
+               e_2,                                                                                &
+               e_3,                                                                                &
+               e_p,                                                                                &
+               kh,                                                                                 &
+               km,                                                                                 &
+               mean_inflow_profiles,                                                               &
+               prho,                                                                               &
+               pt,                                                                                 &
+               tdiss_m,                                                                            &
+               te_m,                                                                               &
+               tend,                                                                               &
+               u,                                                                                  &
+               v,                                                                                  &
+               vpt,                                                                                &
+               w
+
+    USE basic_constants_and_equations_mod,                                                         &
+        ONLY:  g,                                                                                  &
+               kappa,                                                                              &
+               lv_d_cp,                                                                            &
+               lv_d_rd,                                                                            &
+               rd_d_rv
+
+    USE control_parameters,                                                                        &
+        ONLY:  bc_dirichlet_l,                                                                     &
+               bc_dirichlet_n,                                                                     &
+               bc_dirichlet_r,                                                                     &
+               bc_dirichlet_s,                                                                     &
+               bc_radiation_l,                                                                     &
+               bc_radiation_n,                                                                     &
+               bc_radiation_r,                                                                     &
+               bc_radiation_s,                                                                     &
+               child_domain,                                                                       &
+               constant_diffusion,                                                                 &
+               current_timestep_number,                                                            &
+               dt_3d,                                                                              &
+               e_init,                                                                             &
+               humidity,                                                                           &
+               initializing_actions,                                                               &
+               intermediate_timestep_count,                                                        &
+               intermediate_timestep_count_max,                                                    &
+               km_constant,                                                                        &
+               les_dai,                                                                            &
+               les_dynamic,                                                                        &
+               les_default,                                                                        &
+               ocean_mode,                                                                         &
+               plant_canopy,                                                                       &
+               prandtl_number,                                                                     &
+               pt_reference,                                                                       &
+               rans_mode,                                                                          &
+               rans_tke_e,                                                                         &
+               rans_tke_l,                                                                         &
+               timestep_scheme,                                                                    &
+               turbulence_closure,                                                                 &
+               turbulent_inflow,                                                                   &
+               use_upstream_for_tke,                                                               &
+               vpt_reference,                                                                      &
+               ws_scheme_sca
+
+
+    USE advec_ws,                                                                                  &
         ONLY:  advec_s_ws
 
-    USE advec_s_bc_mod,                                                       &
+    USE advec_s_bc_mod,                                                                            &
         ONLY:  advec_s_bc
 
-    USE advec_s_pw_mod,                                                       &
+    USE advec_s_pw_mod,                                                                            &
         ONLY:  advec_s_pw
 
-    USE advec_s_up_mod,                                                       &
+    USE advec_s_up_mod,                                                                            &
         ONLY:  advec_s_up
 
-    USE cpulog,                                                               &
+    USE cpulog,                                                                                    &
         ONLY:  cpu_log, log_point_s
 
-    USE indices,                                                              &
-        ONLY:  advc_flags_s,                                                  &
-               nbgp, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt,    &
-               topo_top_ind,                                                  &
+    USE indices,                                                                                   &
+        ONLY:  advc_flags_s,                                                                       &
+               nbgp,                                                                               &
+               nxl,                                                                                &
+               nxlg,                                                                               &
+               nxr,                                                                                &
+               nxrg,                                                                               &
+               nyn,                                                                                &
+               nyng,                                                                               &
+               nys,                                                                                &
+               nysg,                                                                               &
+               nzb,                                                                                &
+               nzt,                                                                                &
+               topo_top_ind,                                                                       &
                wall_flags_total_0
 
     USE kinds
 
-    USE ocean_mod,                                                            &
+    USE ocean_mod,                                                                                 &
         ONLY:  prho_reference
 
     USE pegrid
 
-    USE plant_canopy_model_mod,                                               &
+    USE plant_canopy_model_mod,                                                                    &
         ONLY:  pcm_tendency
 
-    USE statistics,                                                           &
-        ONLY:  hom, hom_sum, statistic_regions
-
-    USE surface_mod,                                                          &
-        ONLY:  bc_h,                                                          &
-               bc_v,                                                          &
-               surf_def_h,                                                    &
-               surf_def_v,                                                    &
-               surf_lsm_h,                                                    &
-               surf_lsm_v,                                                    &
-               surf_usm_h,                                                    &
+    USE statistics,                                                                                &
+        ONLY:  hom,                                                                                &
+               hom_sum,                                                                            &
+               statistic_regions
+
+    USE surface_mod,                                                                               &
+        ONLY:  bc_h,                                                                               &
+               bc_v,                                                                               &
+               surf_def_h,                                                                         &
+               surf_def_v,                                                                         &
+               surf_lsm_h,                                                                         &
+               surf_lsm_v,                                                                         &
+               surf_usm_h,                                                                         &
                surf_usm_v
 
@@ -225,17 +276,19 @@
     REAL(wp) ::  wall_adjustment_factor = 1.8_wp  !< adjustment factor for mixing length
 
-    REAL(wp), DIMENSION(0:4) :: rans_const_c = &        !< model constants for RANS mode (namelist param)
-       (/ 0.55_wp, 1.44_wp, 1.92_wp, 1.44_wp, 0.0_wp /) !> default values fit for standard-tke-e closure
-
-    REAL(wp), DIMENSION(2) :: rans_const_sigma = &      !< model constants for RANS mode, sigma values (namelist param)
-       (/ 1.0_wp, 1.30_wp /)                            !> (sigma_e, sigma_diss)
-
-    REAL(wp), ALLOCATABLE, DIMENSION(:)     ::  ml_blackadar             !< mixing length according to Blackadar
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::  delta                    !< grid size, possibly limited by wall adjustment factor
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::  distance_to_wall         !< distance to the surface/wall
+    REAL(wp), DIMENSION(0:4) ::  rans_const_c = &        !< model constants for RANS mode (namelist param)
+       (/ 0.55_wp, 1.44_wp, 1.92_wp, 1.44_wp, 0.0_wp /)  !> default values fit for standard-tke-e closure
+
+    REAL(wp), DIMENSION(2) ::  rans_const_sigma = &      !< model constants for RANS mode, sigma values (namelist param)
+       (/ 1.0_wp, 1.30_wp /)                             !> (sigma_e, sigma_diss)
+
+    REAL(wp), ALLOCATABLE, DIMENSION(:)     ::  ml_blackadar      !< mixing length according to Blackadar
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::  delta             !< grid size, possibly limited by wall adjustment factor
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::  distance_to_wall  !< distance to the surface/wall
 
 !
 !-- Public variables
-    PUBLIC c_0, rans_const_c, rans_const_sigma
+    PUBLIC c_0,                                                                                    &
+           rans_const_c,                                                                           &
+           rans_const_sigma
 
     SAVE
@@ -244,18 +297,20 @@
 !
 !-- Public subroutines
-    PUBLIC                                                                     &
-       tcm_boundary_conds,                                                     &
-       tcm_check_parameters,                                                   &
-       tcm_check_data_output,                                                  &
-       tcm_define_netcdf_grid,                                                 &
-       tcm_init_arrays,                                                        &
-       tcm_init,                                                               &
-       tcm_actions,                                                            &
-       tcm_prognostic_equations,                                               &
-       tcm_swap_timelevel,                                                     &
-       tcm_3d_data_averaging,                                                  &
-       tcm_data_output_2d,                                                     &
-       tcm_data_output_3d,                                                     &
-       tcm_diffusivities
+    PUBLIC  tcm_actions,                                                                           &
+            tcm_boundary_conds,                                                                    &
+            tcm_check_parameters,                                                                  &
+            tcm_check_data_output,                                                                 &
+            tcm_data_output_2d,                                                                    &
+            tcm_data_output_3d,                                                                    &
+            tcm_define_netcdf_grid,                                                                &
+            tcm_diffusivities,                                                                     &
+            tcm_init_arrays,                                                                       &
+            tcm_init,                                                                              &
+            tcm_prognostic_equations,                                                              &
+            tcm_swap_timelevel,                                                                    &
+            tcm_3d_data_averaging
+
+
+
 
 !
@@ -342,12 +397,12 @@
  CONTAINS
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Check parameters routine for turbulence closure module.
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE tcm_boundary_conds
 
-    USE pmc_interface,                                                         &
+    USE pmc_interface,                                                                             &
         ONLY : rans_mode_parent
 
@@ -364,6 +419,5 @@
 !
 !--    In LES mode, Neumann conditions with de/x_i=0 are assumed at solid walls.
-!--    Note, only TKE is prognostic in this case and dissipation is only
-!--    a diagnostic quantity.
+!--    Note, only TKE is prognostic in this case and dissipation is only a diagnostic quantity.
        IF ( .NOT. rans_mode )  THEN
 !
@@ -384,9 +438,8 @@
           DO  l = 0, 3
 !
-!--          Note concerning missing ACC directive for this loop: Even though
-!--          the data structure bc_v is present, it may not contain any
-!--          allocated arrays in the flat but also in a topography case,
-!--          leading to a runtime error. Therefore, omit ACC directives
-!--          for this loop, in contrast to the bc_h loop.
+!--          Note concerning missing ACC directive for this loop: Even though the data structure
+!--          bc_v is present, it may not contain any allocated arrays in the flat but also in a
+!--          topography case, leading to a runtime error. Therefore, omit ACC directives for this
+!--          loop, in contrast to the bc_h loop.
              !$OMP PARALLEL DO PRIVATE( i, j, k )
              DO  m = 1, bc_v(l)%ns
@@ -402,6 +455,6 @@
 !
 !--       Use wall function within constant-flux layer
-!--       Note, grid points listed in bc_h are not included in any calculations in RANS mode and
-!--       are therefore not set here.
+!--       Note, grid points listed in bc_h are not included in any calculations in RANS mode and are
+!--       therefore not set here.
 !
 !--       Upward-facing surfaces
@@ -459,15 +512,13 @@
        ENDIF
 !
-!--    Set Neumann boundary condition for TKE at model top. Do this also
-!--    in case of a nested run.
+!--    Set Neumann boundary condition for TKE at model top. Do this also in case of a nested run.
        !$ACC KERNELS PRESENT(e_p)
        e_p(nzt+1,:,:) = e_p(nzt,:,:)
        !$ACC END KERNELS
 !
-!--    Nesting case: if parent operates in RANS mode and child in LES mode,
-!--    no TKE is transfered. This case, set Neumann conditions at lateral and
-!--    top child boundaries.
-!--    If not ( both either in RANS or in LES mode ), TKE boundary condition
-!--    is treated in the nesting.
+!--    Nesting case: if parent operates in RANS mode and child in LES mode, no TKE is transfered.
+!--    This case, set Neumann conditions at lateral and top child boundaries.
+!--    If not ( both either in RANS or in LES mode ), TKE boundary condition is treated in the
+!--    nesting.
        If ( child_domain )  THEN
           IF ( rans_mode_parent  .AND.  .NOT. rans_mode )  THEN
@@ -482,11 +533,9 @@
        ENDIF
 !
-!--    At in- and outflow boundaries also set Neumann boundary conditions
-!--    for the SGS-TKE. An exception is made for the child domain if
-!--    both parent and child operate in RANS mode. This case no
-!--    lateral Neumann boundary conditions will be set but Dirichlet
-!--    conditions will be set in the nesting.
-       IF ( .NOT. child_domain  .AND.  .NOT. rans_mode_parent  .AND.           &
-            .NOT. rans_mode )  THEN
+!--    At in- and outflow boundaries also set Neumann boundary conditions for the SGS-TKE. An
+!--    exception is made for the child domain if both parent and child operate in RANS mode. This
+!--    case no lateral Neumann boundary conditions will be set but Dirichlet conditions will be set
+!--    in the nesting.
+       IF ( .NOT. child_domain  .AND.  .NOT. rans_mode_parent  .AND.  .NOT. rans_mode )  THEN
           IF ( bc_dirichlet_s  .OR.  bc_radiation_s )  THEN
              e_p(:,nys-1,:) = e_p(:,nys,:)
@@ -519,6 +568,5 @@
           j = surf_def_h(0)%j(m)
           k = surf_def_h(0)%k(m)
-          diss_p(k,j,i) = surf_def_h(0)%us(m)**3          &
-                        / ( kappa * surf_def_h(0)%z_mo(m) )
+          diss_p(k,j,i) = surf_def_h(0)%us(m)**3 / ( kappa * surf_def_h(0)%z_mo(m) )
        ENDDO
 !
@@ -528,6 +576,5 @@
           j = surf_lsm_h%j(m)
           k = surf_lsm_h%k(m)
-          diss_p(k,j,i) = surf_lsm_h%us(m)**3          &
-                        / ( kappa * surf_lsm_h%z_mo(m) )
+          diss_p(k,j,i) = surf_lsm_h%us(m)**3 / ( kappa * surf_lsm_h%z_mo(m) )
        ENDDO
 !
@@ -537,6 +584,5 @@
           j = surf_usm_h%j(m)
           k = surf_usm_h%k(m)
-          diss_p(k,j,i) = surf_usm_h%us(m)**3          &
-                        / ( kappa * surf_usm_h%z_mo(m) )
+          diss_p(k,j,i) = surf_usm_h%us(m)**3 / ( kappa * surf_usm_h%z_mo(m) )
        ENDDO
 !
@@ -549,6 +595,5 @@
              j = surf_def_v(l)%j(m)
              k = surf_def_v(l)%k(m)
-             diss_p(k,j,i) = surf_def_v(l)%us(m)**3          &
-                           / ( kappa * surf_def_v(l)%z_mo(m) )
+             diss_p(k,j,i) = surf_def_v(l)%us(m)**3 / ( kappa * surf_def_v(l)%z_mo(m) )
           ENDDO
 !
@@ -558,6 +603,5 @@
              j = surf_lsm_v(l)%j(m)
              k = surf_lsm_v(l)%k(m)
-             diss_p(k,j,i) = surf_lsm_v(l)%us(m)**3          &
-                           / ( kappa * surf_lsm_v(l)%z_mo(m) )
+             diss_p(k,j,i) = surf_lsm_v(l)%us(m)**3 / ( kappa * surf_lsm_v(l)%z_mo(m) )
           ENDDO
 !
@@ -567,18 +611,14 @@
              j = surf_usm_v(l)%j(m)
              k = surf_usm_v(l)%k(m)
-             diss_p(k,j,i) = surf_usm_v(l)%us(m)**3          &
-                           / ( kappa * surf_usm_v(l)%z_mo(m) )
+             diss_p(k,j,i) = surf_usm_v(l)%us(m)**3 / ( kappa * surf_usm_v(l)%z_mo(m) )
           ENDDO
        ENDDO
 !
-!--    Limit change of diss to be between -90% and +100%. Also, set an absolute
-!--    minimum value
+!--    Limit change of diss to be between -90% and +100%. Also, set an absolute minimum value
        DO  i = nxl, nxr
           DO  j = nys, nyn
              DO  k = nzb, nzt+1
-                diss_p(k,j,i) = MAX( MIN( diss_p(k,j,i),          &
-                                          2.0_wp * diss(k,j,i) ), &
-                                     0.1_wp * diss(k,j,i),        &
-                                     0.0001_wp )
+                diss_p(k,j,i) = MAX( MIN( diss_p(k,j,i), 2.0_wp * diss(k,j,i) ),                   &
+                                          0.1_wp * diss(k,j,i), 0.0001_wp )
              ENDDO
           ENDDO
